# Make_page.pm ʸP225˹碌ơPage.pm6-3ˤΥ֥롼build_page
# make_page˽⥸塼
package Socalsail::Make_page;

use strict;

BEGIN {
    use Exporter   ();
    use vars       qw(@ISA @EXPORT @EXPORT_OK $VERSION);
    $VERSION     = '0.01';
    @ISA         = qw(Exporter);
    @EXPORT      = qw();
    @EXPORT_OK   = qw(read_page build_page write_page);
}

sub read_page {
    # ХѥͿ뤳Ȥǵư롣&build_pageϤΥϥå֤
    my $pathname = shift;
    my %return_hash;

    open IN, "$pathname"
        or die "[ɤ߹] $pathname򳫤ȤǤޤǤ: $!";
    my $page = join '', <IN>;
    close IN;

    return unless $page;

    if ($page =~ m#<TITLE>(.*)</TITLE>#i) {
        $return_hash{title} = $1;
    }

    while ($page =~ m#<META\s+NAME="([^"]+)"\s+CONTENT="([^"]*)">#gi) {
        $return_hash{$1} = $2;
    }

    if ($page =~
        /.+<!begin content>\s*(.+?)\s*<!end content>/s) {
        $return_hash{content} = $1;
    }

    return %return_hash;
}

sub make_page {
    # ϥåΥѥ᡼äƥСեڡꡢ֤
    my %param = (
        type         =>    '',                            # ǥե
        title        =>    'ȥΤʤɥ',  # ǥե
        description  =>    '',
        keywords     =>    '',
        content      =>    '',
        @_,                # ä̾ͤΥڥ
    );

    # ƥץ졼Ȥ뤿ᡢʣMETAѥ᡼1Ĥͤꡢ
    # $meta_block
    my @meta_params = qw(type description keywords
                         name writer editor illustrator
                         photographer);
    my $meta_block = '';

    foreach my $meta_param (@meta_params) {
        if ($param{$meta_param}) {
            $meta_block .= <<EndOfText;
<META NAME="$meta_param" CONTENT="$param{$meta_param}">
EndOfText
            delete $param{$meta_param};
        }
    }

    $param{meta_block} = $meta_block;

    my $template = <<EndOfText;
<HTML lang="ja">
<HEAD>
<META http-equiv="Content-Type" content="text/html; charset=EUC-JP">
<TITLE>%%title%%</TITLE>
%%meta_block%%
</HEAD>
<BODY>
<!--begin content-->

%%content%%

<!--end content-->
</BODY>
</HTML>
EndOfText

    # %%%%ʬ%paramϥå֤ͤ
    $template =~ s{ %% ( .*? ) %% }
                  { exists( $param{$1} )
                          ? $param{$1}
                          : ''
                  }gex;
    return $template;
}

sub write_page {
    # ХѥHTMLƤƤƵưꤵ줿˥ڡ񤭽Ф
    # ɬפ˱ƻꤵ줿ˤɤĤޤǥǥ쥯ȥ
    # ̾ΥƥȥեʳΥڡ¸ߤϷٹȯ񤭹ޤ
    # undef(̤)֤
    my($full_path, $made_page) = @_;
    unless ($full_path =~ /\.html$/) {
        warn "$full_path'.html'ǽäƤޤ\n";
        return;
    }
    unless ($full_path =~ /^\//) {
        warn "$full_pathϥåǻϤޤäƤޤ\n";
        return;
    }
    if (-l $full_path) {
        warn "$full_pathϥܥå󥯤Ǥ\n";
        return;
    }
    if (-B $full_path) {
        warn "$full_pathϥХʥեǤ\n";
        return;
    }

    # ɬפʥǥ쥯ȥ
    my $dir_path = $full_path;
    $dir_path    =~ s{/[^/]+$}{}; # '/'ˤե̾

    &make_dirs($dir_path)
        or die "'&make_dirs''$dir_path'꤬ޤ";

    open OUT, ">$full_path" or
        die "[񤭹] $full_path򳫤ȤǤޤ: $!";
    print OUT $made_page;
    close OUT or
        die "[񤭹߸]$full_pathΥեϥɥĤ뤳ȤǤޤ: $!";

    chmod 0644, $full_path or
        die "$full_pathΥѡߥå0644ѹǤޤ";
    1;
}

sub make_dirs {
    # ХѥƤ뤳Ȥǵư
    # ѥ̾'/'ʬ䤷ơǥ쥯ȥ̾뤫å
    # ¸ߤʤС0755Υѡߥåǥǥ쥯ȥ
    # ʬ䤷ǸǤ˥ԥꥪɤޤޤƤϡǥ쥯ȥʤ褦˥åפ
    # (㡧'/foo/index.html/')
    # ե̾ޤѥϤΥ֥롼ˤϤʤ
    # ¤ΥƥݤΤᡢͿ줿˥ԥꥪɤ2¤Ǥ('..')
    # ¹Ԥߤ
    umask 0000;
    my $full_path = shift;
    return if $full_path =~ /\.\./; # ǥ쥯ȥ̾'..'ޤϡѤʤ
    my @dirs = split(/\//, $full_path);

    my $last_element = pop @dirs;
    unless ($last_element =~ /\./) {
        push @dirs, $last_element;  # '.'ޤޤƤʤɲä
    }

    my $this_dir;

    foreach (@dirs) {
        next unless $_; # 
        $this_dir .= "/$_";
        if (-e $this_dir) {
            unless (-d $this_dir) {
                warn "$this_dir¸ߤޤǥ쥯ȥǤϤޤ\n";
                return;
            }
        } else {
            mkdir $this_dir, 0755
                or die "$this_dirǥ쥯ȥκ˼Ԥޤ: $!";
        }
    }
    return 1;
}

1;
